const C3 = self.C3;

const BEHAVIOR_INFO = {
    id: "skymen_buffed_value",
    Acts: {
      "SetValue": {
            "forward": (inst) => inst._SetValue,
            
            "autoScriptInterface": true,
            },
"SetMax": {
            "forward": (inst) => inst._SetMax,
            
            "autoScriptInterface": true,
            },
"SetMin": {
            "forward": (inst) => inst._SetMin,
            
            "autoScriptInterface": true,
            },
"ApplyPercentBuff": {
            "forward": (inst) => inst._ApplyPercentBuff,
            
            "autoScriptInterface": true,
            },
"ApplyFixedBuff": {
            "forward": (inst) => inst._ApplyFixedBuff,
            
            "autoScriptInterface": true,
            },
"StopBuff": {
            "forward": (inst) => inst._StopBuff,
            
            "autoScriptInterface": true,
            },
"StopAllBuffs": {
            "forward": (inst) => inst._StopAllBuffs,
            
            "autoScriptInterface": true,
            }
    },
    Cnds: {
      "HasAnyBuff": {
            "forward": (inst) => inst._HasAnyBuff,
            
            "autoScriptInterface": true,
          },
"HasBuff": {
            "forward": (inst) => inst._HasBuff,
            
            "autoScriptInterface": true,
          },
"IsAtMax": {
            "forward": (inst) => inst._IsAtMax,
            
            "autoScriptInterface": true,
          },
"IsAtMin": {
            "forward": (inst) => inst._IsAtMin,
            
            "autoScriptInterface": true,
          },
"OnBuffStarted": {
            "forward": (inst) => inst._OnBuffStarted,
            
            "autoScriptInterface": true,
          },
"OnBuffEnded": {
            "forward": (inst) => inst._OnBuffEnded,
            
            "autoScriptInterface": true,
          },
"OnAnyBuffStarted": {
            "forward": (inst) => inst._OnAnyBuffStarted,
            
            "autoScriptInterface": true,
          },
"OnAnyBuffEnded": {
            "forward": (inst) => inst._OnAnyBuffEnded,
            
            "autoScriptInterface": true,
          },
"ForEachBuff": {
            "forward": (inst) => inst._ForEachBuff,
            
            "autoScriptInterface": false,
          },
"ForEachPercentBuff": {
            "forward": (inst) => inst._ForEachPercentBuff,
            
            "autoScriptInterface": false,
          },
"ForEachStaticBuff": {
            "forward": (inst) => inst._ForEachStaticBuff,
            
            "autoScriptInterface": false,
          }
    },
    Exps: {
      "Value": {
            "forward": (inst) => inst._Value,
            
            "autoScriptInterface": true,
          },
"BaseValue": {
            "forward": (inst) => inst._BaseValue,
            
            "autoScriptInterface": true,
          },
"RawValue": {
            "forward": (inst) => inst._RawValue,
            
            "autoScriptInterface": true,
          },
"Max": {
            "forward": (inst) => inst._Max,
            
            "autoScriptInterface": true,
          },
"Min": {
            "forward": (inst) => inst._Min,
            
            "autoScriptInterface": true,
          },
"AllPercentBuffs": {
            "forward": (inst) => inst._AllPercentBuffs,
            
            "autoScriptInterface": true,
          },
"AllFixedBuffs": {
            "forward": (inst) => inst._AllFixedBuffs,
            
            "autoScriptInterface": true,
          },
"BuffCount": {
            "forward": (inst) => inst._BuffCount,
            
            "autoScriptInterface": true,
          },
"BuffTime": {
            "forward": (inst) => inst._BuffTime,
            
            "autoScriptInterface": true,
          },
"FixedBuffValue": {
            "forward": (inst) => inst._FixedBuffValue,
            
            "autoScriptInterface": true,
          },
"PercentBuffValue": {
            "forward": (inst) => inst._PercentBuffValue,
            
            "autoScriptInterface": true,
          },
"BuffProgress": {
            "forward": (inst) => inst._BuffProgress,
            
            "autoScriptInterface": true,
          },
"BuffDuration": {
            "forward": (inst) => inst._BuffDuration,
            
            "autoScriptInterface": true,
          },
"LastBuff": {
            "forward": (inst) => inst._LastBuff,
            
            "autoScriptInterface": true,
          }
    },
  };

const camelCasedMap = new Map();

function camelCasify(str) {
  // If the string is already camelCased, return it
  if (camelCasedMap.has(str)) {
    return camelCasedMap.get(str);
  }
  // Replace any non-valid JavaScript identifier characters with spaces
  let cleanedStr = str.replace(/[^a-zA-Z0-9$_]/g, " ");

  // Split the string on spaces
  let words = cleanedStr.split(" ").filter(Boolean);

  // Capitalize the first letter of each word except for the first one
  for (let i = 1; i < words.length; i++) {
    words[i] = words[i].charAt(0).toUpperCase() + words[i].substring(1);
  }

  // Join the words back together
  let result = words.join("");

  // If the first character is a number, prepend an underscore
  if (!isNaN(parseInt(result.charAt(0)))) {
    result = "_" + result;
  }

  camelCasedMap.set(str, result);

  return result;
}

C3.Behaviors[BEHAVIOR_INFO.id] = class extends C3.SDKBehaviorBase {
  constructor(opts) {
    super(opts);
  }

  Release() {
    super.Release();
  }
};
const B_C = C3.Behaviors[BEHAVIOR_INFO.id];
B_C.Type = class extends C3.SDKBehaviorTypeBase {
  constructor(objectClass) {
    super(objectClass);
  }

  Release() {
    super.Release();
  }

  OnCreate() {}
};

//====== SCRIPT INTERFACE ======
const map = new WeakMap();

function getScriptInterface(parentClass, map) {
  return class extends parentClass {
    constructor() {
      super();
      map.set(this, parentClass._GetInitInst().GetSdkInstance());
    }
  };
}


const scriptInterface = getScriptInterface(self.IBehaviorInstance, map);

// extend script interface with plugin actions
Object.keys(BEHAVIOR_INFO.Acts).forEach((key) => {
  const ace = BEHAVIOR_INFO.Acts[key];
  if (!ace.autoScriptInterface) return;
  scriptInterface.prototype[camelCasify(key)] = function (...args) {
    const sdkInst = map.get(this);
    B_C.Acts[camelCasify(key)].call(sdkInst, ...args);
  };
});

const addonTriggers = [];

// extend script interface with plugin conditions
Object.keys(BEHAVIOR_INFO.Cnds).forEach((key) => {
  const ace = BEHAVIOR_INFO.Cnds[key];
  if (!ace.autoScriptInterface || ace.isStatic || ace.isLooping) return;
  if (ace.isTrigger) {
    scriptInterface.prototype[camelCasify(key)] = function (callback, ...args) {
      const callbackWrapper = () => {
        const sdkInst = map.get(this);
        if (B_C.Cnds[camelCasify(key)].call(sdkInst, ...args)) {
          callback();
        }
      };
      this.addEventListener(key, callbackWrapper, false);
      return () => this.removeEventListener(key, callbackWrapper, false);
    };
  } else {
    scriptInterface.prototype[camelCasify(key)] = function (...args) {
      const sdkInst = map.get(this);
      return B_C.Cnds[camelCasify(key)].call(sdkInst, ...args);
    };
  }
});

// extend script interface with plugin expressions
Object.keys(BEHAVIOR_INFO.Exps).forEach((key) => {
  const ace = BEHAVIOR_INFO.Exps[key];
  if (!ace.autoScriptInterface) return;
  scriptInterface.prototype[camelCasify(key)] = function (...args) {
    const sdkInst = map.get(this);
    return B_C.Exps[camelCasify(key)].call(sdkInst, ...args);
  };
});
//====== SCRIPT INTERFACE ======

//============ ACES ============
B_C.Acts = {};
B_C.Cnds = {};
B_C.Exps = {};
Object.keys(BEHAVIOR_INFO.Acts).forEach((key) => {
  const ace = BEHAVIOR_INFO.Acts[key];
  B_C.Acts[camelCasify(key)] = function (...args) {
    if (ace.forward) ace.forward(this).call(this, ...args);
    else if (ace.handler) ace.handler.call(this, ...args);
  };
});
Object.keys(BEHAVIOR_INFO.Cnds).forEach((key) => {
  const ace = BEHAVIOR_INFO.Cnds[key];
  B_C.Cnds[camelCasify(key)] = function (...args) {
    if (ace.forward) return ace.forward(this).call(this, ...args);
    if (ace.handler) return ace.handler.call(this, ...args);
  };
  if (ace.isTrigger && ace.autoScriptInterface) {
    addonTriggers.push({
      method: B_C.Cnds[camelCasify(key)],
      id: key,
    });
  }
});
Object.keys(BEHAVIOR_INFO.Exps).forEach((key) => {
  const ace = BEHAVIOR_INFO.Exps[key];
  B_C.Exps[camelCasify(key)] = function (...args) {
    if (ace.forward) return ace.forward(this).call(this, ...args);
    if (ace.handler) return ace.handler.call(this, ...args);
  };
});
//============ ACES ============

function getInstanceJs(parentClass, scriptInterface, addonTriggers, C3) {
  return class extends parentClass {
    constructor(inst, properties) {
      super(inst);

      this.baseValue = 0;
      this.maxValue = 0;
      this.minValue = 0;
      this.clampMode = 0;
      if (properties) {
        this.baseValue = properties[0];
        this.maxValue = properties[1];
        this.minValue = properties[2];
        this.clampMode = properties[3];
      }

      this.percentBuffs = {};
      this.fixedBuffs = {};
      this.lastBuff = "";

      this._StartTicking();
    }

    Release() {
      super.Release();
    }

    SaveToJson() {
      return {
        baseValue: this.baseValue,
        maxValue: this.maxValue,
        minValue: this.minValue,
        percentBuffs: this.percentBuffs,
        fixedBuffs: this.fixedBuffs,
      };
    }

    LoadFromJson(o) {
      this.baseValue = o.baseValue;
      this.maxValue = o.maxValue;
      this.minValue = o.minValue;
      this.percentBuffs = o.percentBuffs;
      this.fixedBuffs = o.fixedBuffs;
    }

    Trigger(method) {
      super.Trigger(method);
      const addonTrigger = addonTriggers.find((x) => x.method === method);
      if (addonTrigger) {
        this.GetScriptInterface().dispatchEvent(new C3.Event(addonTrigger.id));
      }
    }

    GetScriptInterfaceClass() {
      return scriptInterface;
    }

    clamp(value, min, max) {
      return Math.min(Math.max(value, min), max);
    }

    GetTime() {
      return this._runtime.GetGameTime();
    }

    Tick() {
      const time = this.GetTime();
      // remove expired buffs
      Object.keys(this.percentBuffs).forEach((tag) => {
        const buff = this.percentBuffs[tag];
        if (buff.startTime + buff.duration < time) {
          this.lastBuff = tag;
          this.Trigger(C3.Behaviors.skymen_buffed_value.Cnds.OnBuffEnded);
          this.Trigger(C3.Behaviors.skymen_buffed_value.Cnds.OnAnyBuffEnded);
          delete this.percentBuffs[tag];
        }
      });
      Object.keys(this.fixedBuffs).forEach((tag) => {
        const buff = this.fixedBuffs[tag];
        if (buff.startTime + buff.duration < time) {
          this.lastBuff = tag;
          this.Trigger(C3.Behaviors.skymen_buffed_value.Cnds.OnBuffEnded);
          this.Trigger(C3.Behaviors.skymen_buffed_value.Cnds.OnAnyBuffEnded);
          delete this.fixedBuffs[tag];
        }
      });
    }

    // Actions
    _SetValue(value) {
      this.baseValue = this.clamp(value, this.minValue, this.maxValue);
    }
    _SetMax(value) {
      this.maxValue = value;
      this.baseValue = this.clamp(this.baseValue, this.minValue, this.maxValue);
    }
    _SetMin(value) {
      this.minValue = value;
      this.baseValue = this.clamp(this.baseValue, this.minValue, this.maxValue);
    }
    _ApplyPercentBuff(tag, value, duration) {
      this.percentBuffs[tag] = {
        value,
        duration,
        startTime: this.GetTime(),
      };
      this.lastBuff = tag;
      this.Trigger(C3.Behaviors.skymen_buffed_value.Cnds.OnBuffStarted);
      this.Trigger(C3.Behaviors.skymen_buffed_value.Cnds.OnAnyBuffStarted);
    }
    _ApplyFixedBuff(tag, value, duration) {
      this.fixedBuffs[tag] = {
        value,
        duration,
        startTime: this.GetTime(),
      };
      this.lastBuff = tag;
      this.Trigger(C3.Behaviors.skymen_buffed_value.Cnds.OnBuffStarted);
      this.Trigger(C3.Behaviors.skymen_buffed_value.Cnds.OnAnyBuffStarted);
    }
    _StopBuff(tag) {
      this.lastBuff = tag;
      this.Trigger(C3.Behaviors.skymen_buffed_value.Cnds.OnBuffEnded);
      this.Trigger(C3.Behaviors.skymen_buffed_value.Cnds.OnAnyBuffEnded);
      delete this.percentBuffs[tag];

      delete this.fixedBuffs[tag];
    }
    _StopAllBuffs() {
      Object.keys(this.percentBuffs).forEach((tag) => {
        this.lastBuff = tag;
        this.Trigger(C3.Behaviors.skymen_buffed_value.Cnds.OnBuffEnded);
        this.Trigger(C3.Behaviors.skymen_buffed_value.Cnds.OnAnyBuffEnded);
      });
      Object.keys(this.fixedBuffs).forEach((tag) => {
        this.lastBuff = tag;
        this.Trigger(C3.Behaviors.skymen_buffed_value.Cnds.OnBuffEnded);
        this.Trigger(C3.Behaviors.skymen_buffed_value.Cnds.OnAnyBuffEnded);
      });
      this.percentBuffs = {};
      this.fixedBuffs = {};
    }

    // Conditions
    _HasAnyBuff() {
      return (
        Object.keys(this.percentBuffs).length > 0 ||
        Object.keys(this.fixedBuffs).length > 0
      );
    }
    _HasBuff(tag) {
      return this.percentBuffs[tag] || this.fixedBuffs[tag];
    }
    _IsAtMax() {
      return this.baseValue === this.maxValue;
    }
    _IsAtMin() {
      return this.baseValue === this.minValue;
    }
    _OnBuffStarted(tag) {
      return this.lastBuff === tag;
    }
    _OnBuffEnded(tag) {
      return this.lastBuff === tag;
    }
    _OnAnyBuffStarted() {
      return true;
    }
    _OnAnyBuffEnded() {
      return true;
    }
    _ForEachBuff() {
      // Get necessary references
      const runtime = this._runtime;
      const eventSheetManager = runtime.GetEventSheetManager();
      const currentEvent = runtime.GetCurrentEvent();
      const solModifiers = currentEvent.GetSolModifiers();
      const eventStack = runtime.GetEventStack();

      // Get current stack frame and push new one
      const oldFrame = eventStack.GetCurrentStackFrame();
      const newFrame = eventStack.Push(currentEvent);

      for (const buff of Object.keys({
        ...this.percentBuffs,
        ...this.fixedBuffs,
      })) {
        // ... optionally update state here ...
        this.lastBuff = buff;
        // Push a copy of the current SOL
        eventSheetManager.PushCopySol(solModifiers);

        // Retrigger the current event, running a single loop iteration
        currentEvent.Retrigger(oldFrame, newFrame);

        // Pop the current SOL
        eventSheetManager.PopSol(solModifiers);
      }

      // Pop the event stack frame
      eventStack.Pop();

      // Return false since event already executed
      return false;
    }

    _ForEachPercentBuff() {
      // Get necessary references
      const runtime = this._runtime;
      const eventSheetManager = runtime.GetEventSheetManager();
      const currentEvent = runtime.GetCurrentEvent();
      const solModifiers = currentEvent.GetSolModifiers();
      const eventStack = runtime.GetEventStack();

      // Get current stack frame and push new one
      const oldFrame = eventStack.GetCurrentStackFrame();
      const newFrame = eventStack.Push(currentEvent);

      for (const buff of Object.keys(this.percentBuffs)) {
        // ... optionally update state here ...
        this.lastBuff = buff;
        // Push a copy of the current SOL
        eventSheetManager.PushCopySol(solModifiers);

        // Retrigger the current event, running a single loop iteration
        currentEvent.Retrigger(oldFrame, newFrame);

        // Pop the current SOL
        eventSheetManager.PopSol(solModifiers);
      }

      // Pop the event stack frame
      eventStack.Pop();

      // Return false since event already executed
      return false;
    }
    _ForEachStaticBuff() {
      // Get necessary references
      const runtime = this._runtime;
      const eventSheetManager = runtime.GetEventSheetManager();
      const currentEvent = runtime.GetCurrentEvent();
      const solModifiers = currentEvent.GetSolModifiers();
      const eventStack = runtime.GetEventStack();

      // Get current stack frame and push new one
      const oldFrame = eventStack.GetCurrentStackFrame();
      const newFrame = eventStack.Push(currentEvent);

      for (const buff of Object.keys(this.fixedBuffs)) {
        // ... optionally update state here ...
        this.lastBuff = buff;
        // Push a copy of the current SOL
        eventSheetManager.PushCopySol(solModifiers);

        // Retrigger the current event, running a single loop iteration
        currentEvent.Retrigger(oldFrame, newFrame);

        // Pop the current SOL
        eventSheetManager.PopSol(solModifiers);
      }

      // Pop the event stack frame
      eventStack.Pop();

      // Return false since event already executed
      return false;
    }

    // Expressions
    _Value() {
      return this.clampMode === 0
        ? this.clamp(this._RawValue(), this.minValue, this.maxValue)
        : this._RawValue();
    }
    _BaseValue() {
      return this.baseValue;
    }
    _RawValue() {
      return (
        this.baseValue +
        (this.baseValue * this._AllPercentBuffs()) / 100 +
        this._AllFixedBuffs()
      );
    }
    _Max() {
      return this.maxValue;
    }
    _Min() {
      return this.minValue;
    }
    _AllPercentBuffs() {
      let percentBuff = 0;
      Object.keys(this.percentBuffs).forEach((tag) => {
        const buff = this.percentBuffs[tag];
        percentBuff += buff.value;
      });
      return percentBuff;
    }
    _AllFixedBuffs() {
      let fixedBuff = 0;
      Object.keys(this.fixedBuffs).forEach((tag) => {
        const buff = this.fixedBuffs[tag];
        fixedBuff += buff.value;
      });
      return fixedBuff;
    }
    _BuffCount() {
      return (
        Object.keys(this.percentBuffs).length +
        Object.keys(this.fixedBuffs).length
      );
    }
    _BuffTime(tag) {
      const buff = this.percentBuffs[tag] || this.fixedBuffs[tag];
      if (buff) {
        // return remaining duration
        return buff.duration - (this.GetTime() - buff.startTime);
      }
      return 0;
    }
    _FixedBuffValue(tag) {
      const buff = this.fixedBuffs[tag];
      if (buff) {
        return buff.value;
      }
      return 0;
    }
    _PercentBuffValue(tag) {
      const buff = this.percentBuffs[tag];
      if (buff) {
        return buff.value;
      }
      return 0;
    }
    _BuffProgress(tag) {
      const buff = this.percentBuffs[tag] || this.fixedBuffs[tag];
      if (buff) {
        // return progress
        return (this.GetTime() - buff.startTime) / buff.duration;
      }
      return 0;
    }
    _BuffDuration(tag) {
      const buff = this.percentBuffs[tag] || this.fixedBuffs[tag];
      if (buff) {
        return buff.duration;
      }
      return 0;
    }
    _LastBuff() {
      return this.lastBuff;
    }
  };
}


B_C.Instance = getInstanceJs(
  C3.SDKBehaviorInstanceBase,
  scriptInterface,
  addonTriggers,
  C3
);
